#include "Arduino.h"
#include <Wire.h>
#include "FG02_R5700K.h"

FG02_R5700K::FG02_R5700K(void)
{
}

////////////////////////
// Li-Ion Battery UR18650ZY
//  - Rated capacity: 2450mAh
//  - Nominal Voltage: 3.7V
//  - Charging: CC-CV, 4.2V
////////////////////////
void FG02_R5700K::beginUr18650zy(void)
{
	i2c_write(R5700K_DEV_ADDR, 0x38, 0x94);
	i2c_write(R5700K_DEV_ADDR, 0x39, 0x89);
	i2c_write(R5700K_DEV_ADDR, 0x49, 0x9f);
	i2c_write(R5700K_DEV_ADDR, 0x4a, 0x08);
	i2c_write(R5700K_DEV_ADDR, 0x4f, 0x24);
	i2c_write(R5700K_DEV_ADDR, 0x80, 0xf7);
	i2c_write(R5700K_DEV_ADDR, 0x81, 0xe9);
	i2c_write(R5700K_DEV_ADDR, 0x82, 0xce);
	i2c_write(R5700K_DEV_ADDR, 0x83, 0xa4);
	i2c_write(R5700K_DEV_ADDR, 0x84, 0x74);
	i2c_write(R5700K_DEV_ADDR, 0x85, 0x4b);
	i2c_write(R5700K_DEV_ADDR, 0x86, 0x2f);
	i2c_write(R5700K_DEV_ADDR, 0x87, 0x1d);
	i2c_write(R5700K_DEV_ADDR, 0x88, 0x12);
	i2c_write(R5700K_DEV_ADDR, 0xa0, 0x5c);
	i2c_write(R5700K_DEV_ADDR, 0xa1, 0x0a);
	i2c_write(R5700K_DEV_ADDR, 0xa2, 0x46);
	i2c_write(R5700K_DEV_ADDR, 0xa3, 0x0b);
	i2c_write(R5700K_DEV_ADDR, 0xa4, 0xbe);
	i2c_write(R5700K_DEV_ADDR, 0xa5, 0x0b);
	i2c_write(R5700K_DEV_ADDR, 0xa6, 0x06);
	i2c_write(R5700K_DEV_ADDR, 0xa7, 0x0c);
	i2c_write(R5700K_DEV_ADDR, 0xa8, 0x0d);
	i2c_write(R5700K_DEV_ADDR, 0xa9, 0x0c);
	i2c_write(R5700K_DEV_ADDR, 0xaa, 0x17);
	i2c_write(R5700K_DEV_ADDR, 0xab, 0x0c);
	i2c_write(R5700K_DEV_ADDR, 0xac, 0x50);
	i2c_write(R5700K_DEV_ADDR, 0xad, 0x0c);
	i2c_write(R5700K_DEV_ADDR, 0xae, 0x7b);
	i2c_write(R5700K_DEV_ADDR, 0xaf, 0x0c);
	i2c_write(R5700K_DEV_ADDR, 0xb0, 0xb3);
	i2c_write(R5700K_DEV_ADDR, 0xb1, 0x0c);
	i2c_write(R5700K_DEV_ADDR, 0xb2, 0xf8);
	i2c_write(R5700K_DEV_ADDR, 0xb3, 0x0c);
	i2c_write(R5700K_DEV_ADDR, 0xb4, 0x4c);
	i2c_write(R5700K_DEV_ADDR, 0xb5, 0x0d);
	i2c_write(R5700K_DEV_ADDR, 0xb6, 0x94);
	i2c_write(R5700K_DEV_ADDR, 0xb7, 0x09);
	i2c_write(R5700K_DEV_ADDR, 0xb8, 0x30);
	i2c_write(R5700K_DEV_ADDR, 0xb9, 0x00);
	i2c_write(R5700K_DEV_ADDR, 0x5f, 0x03);
	i2c_write(R5700K_DEV_ADDR, 0x60, 0x01);
	i2c_write(R5700K_DEV_ADDR, 0x61, 0x01);
}

void FG02_R5700K::enableFg(void)
{
	i2c_write(R5700K_DEV_ADDR, R5700K_REG_CONTROL0, 0x41);
}

void FG02_R5700K::setOffset(byte offset)
{
	byte data = 0;
	i2c_write(R5700K_DEV_ADDR, 0xfc, 0x5a);
	i2c_write(R5700K_DEV_ADDR, 0xfc, 0xa5);
	i2c_write(R5700K_DEV_ADDR, 0xfc, 0x5a);
	i2c_write(R5700K_DEV_ADDR, 0xfc, 0xa5);
	i2c_write(R5700K_DEV_ADDR, 0xfc, 0x07);
	i2c_write(R5700K_DEV_ADDR, 0xfc, 0x27);
	i2c_write(R5700K_DEV_ADDR, 0xff, 0x81);

	i2c_write(R5700K_DEV_ADDR, 0x70, 0x6a);
	i2c_write(R5700K_DEV_ADDR, 0x71, 0x18);
	i2c_write(R5700K_DEV_ADDR, 0x72, 0x6a);
	i2c_write(R5700K_DEV_ADDR, 0x73, 0x18);
	i2c_write(R5700K_DEV_ADDR, 0x74, 0x00);
	i2c_write(R5700K_DEV_ADDR, 0x75, 0x00);
	i2c_write(R5700K_DEV_ADDR, 0x76, 0x00);
	i2c_write(R5700K_DEV_ADDR, 0x77, 0x00);

	i2c_write(R5700K_DEV_ADDR, 0x78, offset);

	i2c_write(R5700K_DEV_ADDR, 0xff, 0x00);

}

float FG02_R5700K::getSoc(void)
{
	byte data;
	float soc;

	data = i2c_read(R5700K_DEV_ADDR, R5700K_REG_SSOC);
	soc = (float)data / 2;

	// % unit
	return soc;
}

unsigned int FG02_R5700K::getVoltage(void)
{
	byte dataL;
	byte dataH;
	unsigned int val;
	unsigned long volt;

	dataL = i2c_read(R5700K_DEV_ADDR, R5700K_REG_VOLTAGE_L);
	dataH = i2c_read(R5700K_DEV_ADDR, R5700K_REG_VOLTAGE_H);
	dataH &= 0x0f;
	val = dataH * 256 + dataL;
	volt = (unsigned long)val * 5000 / 4095;

	// mV unit
	return (unsigned int)volt;
}

int FG02_R5700K::getCurrent(void)
{
	byte dataL;
	byte dataH;
	unsigned int val;
	long cur;

	dataL = i2c_read(R5700K_DEV_ADDR, R5700K_REG_CC_AVE_L);
	dataH = i2c_read(R5700K_DEV_ADDR, R5700K_REG_CC_AVE_H);
	dataH &= 0x7f;
	val = dataH * 256 + dataL;

	if(val >= 0x4000)
	{
		cur = (long)val - 0x8000;
	}
	else
	{
		cur = (long)val;
	}

	// mA unit
	return (int)cur;
}

float FG02_R5700K::getTemperature(void)
{
	byte dataL;
	byte dataH;
	unsigned int val;
	float temp;

	dataL = i2c_read(R5700K_DEV_ADDR, R5700K_REG_TEMP_L);
	dataH = i2c_read(R5700K_DEV_ADDR, R5700K_REG_TEMP_H);
	dataH &= 0x0f;
	val = dataH * 256 + dataL;

	if (val >= 0x800)
	{
		temp = ((float)val - 0x1000) / 16;
	}
	else
	{
		temp = (float)val / 16;
	}
	// degC unit
	return temp;
}

unsigned int FG02_R5700K::getTTFull(void)
{
	byte dataL;
	byte dataH;
	unsigned int ttf;

	dataL = i2c_read(R5700K_DEV_ADDR, R5700K_REG_TT_FULL_L);
	dataH = i2c_read(R5700K_DEV_ADDR, R5700K_REG_TT_FULL_H);
	ttf = dataH * 256 + dataL;
	// minute unit
	return ttf;
}

unsigned int FG02_R5700K::getTTEmpty(void)
{
	byte dataL;
	byte dataH;
	unsigned int tte;

	dataL = i2c_read(R5700K_DEV_ADDR, R5700K_REG_TT_EMPTY_L);
	dataH = i2c_read(R5700K_DEV_ADDR, R5700K_REG_TT_EMPTY_H);
	tte = dataH * 256 + dataL;

	// minute unit
	return tte;
}

void FG02_R5700K::setChargeComplete(void)
{
	i2c_write(R5700K_DEV_ADDR, R5700K_REG_CONTROL1, 0xe4);
	i2c_write(R5700K_DEV_ADDR, R5700K_REG_FORCE, 0x01);

	return;
}

void FG02_R5700K::i2c_write(int dev_addr, int reg_addr, int data)
{
	Wire.beginTransmission(dev_addr);
	Wire.write(reg_addr);
	Wire.write(data);
	Wire.endTransmission();
}

byte FG02_R5700K::i2c_read(int dev_addr, int reg_addr)
{
	byte data = 0;

	Wire.beginTransmission(dev_addr);
	Wire.write(reg_addr);
	Wire.endTransmission(false);

	Wire.requestFrom(dev_addr, 1);
	data = Wire.read();

	return data;
}

