#ifndef FG02_R5700K_H_
#define FG02_R5700K_H_
#include "arduino.h"

#define R5700K_DEV_ADDR 0x32

#define R5700K_REG_CONTROL0 0x2a
#define R5700K_REG_CONTROL1 0x2b
#define R5700K_REG_FORCE 0x30
#define R5700K_REG_SSOC 0x35
#define R5700K_REG_TT_EMPTY_L 0x3b
#define R5700K_REG_TT_EMPTY_H 0x3c
#define R5700K_REG_TT_FULL_L 0x3d
#define R5700K_REG_TT_FULL_H 0x3e
#define R5700K_REG_VOLTAGE_L 0x3f
#define R5700K_REG_VOLTAGE_H 0x40
#define R5700K_REG_TEMP_L 0x41
#define R5700K_REG_TEMP_H 0x42
#define R5700K_REG_CHGCMP0 0x4f
#define R5700K_REG_CC_AVE_L 0x92
#define R5700K_REG_CC_AVE_H 0x93

class FG02_R5700K
{
	public:
		FG02_R5700K(void);

	public:
		void beginUr18650zy(void);
		void enableFg(void);
		void setOffset(byte offset);
		float getSoc(void);
		unsigned int getVoltage(void);
		int getCurrent(void);
		float getTemperature(void);
		unsigned int getTTFull(void);
		unsigned int getTTEmpty(void);
		void setChargeComplete(void);

		void i2c_write(int dev_addr, int reg_addr, int data);
		byte i2c_read(int dev_addr, int reg_addr);
};

#endif